=== debian/changelog ===
jh7100-bootloader-recovery (0~2021.07.14~git2b268a1c-3) unstable; urgency=medium

  * Update d/copyright. (Closes: #1052940)

 -- Domenico Andreoli <cavok@debian.org>  Wed, 27 Sep 2023 18:40:48 +0200

jh7100-bootloader-recovery (0~2021.07.14~git2b268a1c-2) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Apply multi-arch hints.
    + jh7100-bootloader-recovery: Add Multi-Arch: foreign.

  [ Domenico Andreoli ]
  * Add 000-drop-date-from-embedded-version.patch, make the build
    reproducible. (Closes: #1024530)
  * Update standards version to 4.6.2, no changes needed.

 -- Domenico Andreoli <cavok@debian.org>  Wed, 25 Jan 2023 14:16:22 +0100

jh7100-bootloader-recovery (0~2021.07.14~git2b268a1c-1) unstable; urgency=medium

  * Initial release. (Closes: #1008492)

 -- Domenico Andreoli <cavok@debian.org>  Fri, 16 Sep 2022 14:37:34 +0200
