=== debian/control ===
Source: jh7100-bootloader-recovery
Priority: optional
Maintainer: Domenico Andreoli <cavok@debian.org>
Build-Depends: debhelper-compat (= 13),
               gcc-riscv64-unknown-elf,
               libconfig-model-dpkg-perl,
               picolibc-riscv64-unknown-elf
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: electronics
Vcs-Browser: https://salsa.debian.org/debian/jh7100-bootloader-recovery
Vcs-Git: https://salsa.debian.org/debian/jh7100-bootloader-recovery.git
Homepage: https://github.com/starfive-tech/bootloader_recovery

Package: jh7100-bootloader-recovery
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: StarFive JH7100 recovery bootloader
 This firmware brings up the board enough to program all the boot stages
 onto the boot flash. It recovers an otherwise unbootable system.
